package com.szls.nstths.controller;

import com.szls.nstths.entity.TeData;
import com.szls.nstths.service.TeDataService;

import java.util.Date;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;


@RestController
public class DataController {

    private static final Logger logger = LoggerFactory.getLogger(DataController.class);

    private TeDataService teDataService;

    @Autowired
    public void setTeDataService(TeDataService teDataService) {
        this.teDataService = teDataService;
    }

    /**
     * 检测后数据
     *
     * @param teData
     * @return
     */
    @PostMapping("/equipmentTestingEnd")
    public String equipmentTesting(@RequestBody TeData teData) {
        logger.info("接收到的数据为{}", teData);
        teData.setEtime(new Date());
        int inum = teDataService.saveTeData(teData);
        if (inum < 0) {
            return "fail";
        }
        teDataService.scanTask(teData);
        return "success";
    }

    /**
     * @param height
     * @param diameter 直径
     */
    @GetMapping("/scanning")
    public void scanning(@RequestParam(value = "height", defaultValue = "35") double height,
                         @RequestParam(value = "diameter ", defaultValue = "12") double diameter) {

        logger.info("scanning height{},diameter{}", height, diameter);
        teDataService.scanTask(diameter, height);
    }
}
