package com.szls.nstths.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.szls.nstths.entity.ReMsg;
import com.szls.nstths.entity.STask;
import com.szls.nstths.entity.TeData;
import com.szls.nstths.mapper.ReMsgMapper;
import com.szls.nstths.mapper.STaskMapper;
import com.szls.nstths.mapper.TeDataMapper;
import com.szls.nstths.service.TeDataService;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Service(value = "teDataService")
public class TeDataServiceImpl implements TeDataService {

    private static final Logger logger = LoggerFactory.getLogger(TeDataServiceImpl.class);

    static String base_url = "http://192.168.0.61:4017/";
    static boolean flag = true;
    static double diameter = 12; //直径
    static double high = 35; //圆筒仓的高(以地面为基准面)
    static double h1 = 6; //h1 圆锥的高
    static double h2 = 3; //h2 水平地面到圆锥尖的高
    private STaskMapper sTaskMapper;
    private TeDataMapper teDataMapper;
    private ReMsgMapper reMsgMapper;

    public static void main(String[] args) {
        String str = "18,7,17.88-19,6,28.88-17,4,39.88";

        str.split("-");
    }

    @Autowired
    public void setsTaskMapper(STaskMapper sTaskMapper) {
        this.sTaskMapper = sTaskMapper;
    }

    @Autowired
    public void setTeDataMapper(TeDataMapper teDataMapper) {
        this.teDataMapper = teDataMapper;
    }

    @Autowired
    public void setReMsgMapper(ReMsgMapper reMsgMapper) {
        this.reMsgMapper = reMsgMapper;
    }

    /**
     * todo
     * http://local.wxlxit.com:61001/
     * 1. equipmentTestingIsReady
     * 2. equipmentTestingStart
     * 3. equipmentTestingEnd
     */
    @Override
    public void scanTask(double diameter, double high) {
        logger.info("scanTask {},{}",diameter,high);
        STask task = new STask();
        Date date = new Date();
        task.setCtime(date);
        task.setDepict("test");
        sTaskMapper.insert(task);

        TeData teData = new TeData();
        teData.setEquipmentID("hljcbk1001");
        teData.setTaskID("" + task.getId());
        teData.setStime(date);

        //todo 第一次待打点
        String rotationxy = Algorithm.getAveragePosition(diameter, high);
        teData.setRotationxy(rotationxy);
        //int inum = teDataMapper.insert(teData);

        logger.info("scanTask sTaskMapper teDataMapper {},{}",task,teData);

        postHelper(teData);
        //equipmentTestingEnd
        flag = true;

    }
    @Async
    @Override
    public void scanTask(TeData teData) {
        try {
            Thread.sleep(10000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        //只运行 发送一次。
        if (flag) {
            //teData.getEquipmentID();
            //teData.getTaskID();

            //todo 第二次待打点

            //计算以粮面为基准面的高
            double zHeight = Algorithm.zHeight(teData.getRotationxy(), diameter, high);
            logger.info("zHeight {} ，diameter {}",zHeight,diameter);

            //打点
            String rotationxy = Algorithm.getAveragePosition(diameter, zHeight);
            teData.setRotationxy(rotationxy);
            teData.setStime(new Date());//第二次开始的时间
            
            postHelper(teData);

            flag = false;
        } else { //打点两次完毕 计算体积
            this.calculateVolume(teData.getTaskID());
        }

    }

    @Override
    public int saveTeData(TeData teData) {
        int inum = teDataMapper.insert(teData);
        return inum;
    }

    public ReMsg postHelper(TeData teData) {

        logger.info("in ...... postHelper teData{}",teData);

        RestTemplate restTemplate = new RestTemplate();
        teData.setCurrenttime(new Date());
        ReMsg reMsg1 = restTemplate.postForObject(base_url + "equipmentTestingIsReady", teData, ReMsg.class);
        //reMsgMapper.insert(reMsg1);
        logger.info("postHelper reMsg1 {}",reMsg1);

        if (reMsg1 != null) {
            if ("0".equals(reMsg1.getCode())) {
                ReMsg reMsg2 = restTemplate.postForObject(base_url + "equipmentTestingStart", teData, ReMsg.class);
                logger.info("postHelper reMsg2 {}",reMsg2);
                reMsgMapper.insert(reMsg2);
                return reMsg2;
            }
        }
        logger.info("postHelper post task_ {}",teData);

        return null;
    }

    @Override
    public void calculateVolume(String taskID) {
        // TODO Auto-generated method stub
    	StringBuffer sb = new StringBuffer();
    	
        List<Double> zList = new ArrayList<Double>();
        double v = 0;
        QueryWrapper<TeData> queryWrapper = new QueryWrapper<>();

        List<TeData> teDataList = null;
        queryWrapper.eq("taskID", taskID);
        teDataList = teDataMapper.selectList(queryWrapper);
        
        if(teDataList.size()>0){
        	for (TeData teData : teDataList) {
        		sb.append(teData.getRotationxy()+";");
            }
        	String rotationxy = sb.substring(0, sb.length()-1).toString();//发送的角度和返回的距离  150,50,90;200,-100,90;50,-50,90
    		
    		//获取有效的z值
        	 zList = Algorithm.getValidZ(rotationxy, diameter, high);
            
    		//计算体积
            v = Algorithm.calculateVolume(zList, diameter, h1, h2); //体积
        }
        logger.info("体积是: {}",v);

    }

}
